# ---------------------------------------------------------------------------
# PreConv - A Plugin for Movable Type
#
# Release 0.9
# October 22, 2004
#
# Author: nlog(n)
# http://nlogn.ath.cx/
#
# Copyright (c) 2004 nlog(n) All rights reserved.
# ---------------------------------------------------------------------------

package MT::Plugins::PreConv;

use strict;
use MT::Template::Context;
MT::Template::Context->add_container_tag(CPreConv => \&CPreConv);

use vars qw($VERSION);
$VERSION = 0.9;

sub CPreConv {
  my ($ctx, $args) = @_;

  my $tokens = $ctx->stash('tokens');
  my $builder = $ctx->stash('builder');

  defined(my $out = $builder->build($ctx, $tokens))
    or return $ctx->error($builder->errstr);

  $out =~ s/(<pre>.*?<\/pre>)/sp2amp($1)/eigs;

  $out;
}
1;

sub sp2amp {
  my $code = shift(@_);
  $code =~ s|<pre>||i;
  $code =~ s|</pre>||i;
  $code =~ s|^\n||s;
  $code =~ s|(.*?)\t|$1 . (' ' x (8 - length($1) % 8))|eg;
  $code =~ s|  | &nbsp;|g;
  $code =~ s|^ |&nbsp;|mg;
  $code =~ s|\n|<br />\n|sg;
  $code = q|<div class="precode">| . $code . q|</div>|;
  $code;
}
